Subject: Bug#402: [X2Go-Dev] Bug#402: Bug#402: Numlock issues

From: Mike Gabriel <[email-masked]>
Date: Wed, 02 Apr 2014 13:00:29 +0000

Control: tag -1 moreinfo

Hi Jordi,

On  Do 30 Jan 2014 09:46:04 CET, jordi wrote:

>> Package: x2goserver
>> Version: 4.0.1.12-0x2go2+git20140108.809+wheezy.main.1
>>
>> Hello, numlock does not behave correctly. It behaves like if it was
>> randomly and continuously toggling it state.
>>
>> Happens when numlock key is pressed, and after some time, it seems to
>> stabilize in some state (on or off), but it can take some time.
>>
>> Happens on Mate 1.6 desktop environment over Debian 6. No problem on same
>> host with a KDE session.
>>
>> If numlock state is modified with numlockx binary, it works as expected,
>> only the key triggers this.
>>
>> user@host:~$ while numlockx status; do sleep 0.1; done
>> Numlock is off
>> Numlock is off
>> Numlock is on
>> Numlock is on
>> Numlock is off
>> Numlock is on
>> Numlock is off
>> Numlock is on
>> Numlock is off
>> Numlock is on
>> Numlock is off
>> Numlock is off
>> Numlock is on
>> Numlock is on
>> Numlock is off
>> Numlock is on
>> Numlock is on
>> ...
>
> Found that the Mate setting which makes numlock state change at a very
> high rate can be disabled by:
>   gsettings set org.mate.peripherals-keyboard remember-numlock-state false
>
> Still, users notify me that numlock change randomly. I did monitor
> numlock status with "numlockx status" command, and I can see it do
> change but very intermitently.
>
> I first monitored numlock status and actively changed it to on with a
> script.
>
> Lately, I added to the keyboard options, the equivalent to "setxkbmap -o
> numpad:mac", which can be added to
> /org/mate/desktop/peripherals/keyboard/kbd/options with
> 'compat\tnumpad:mac'
>
> Here is a dirty script, which every user runs at session startup:
>
> ---------------%-----------------%------------------%------------------
> #!/bin/bash
> tab="$(printf "\t")"
> cadena=( $(dconf read /org/mate/desktop/peripherals/keyboard/kbd/options |
> sed -e 's/.*\[\|\]//g') )
> for (( i=0;i<${#cadena[@]};i++ )); do
> 	# esborrar '[', ']' i ','
> 	cadena[$i]="$(printf "${cadena[$i]}" | sed -e 's/,//g')"
> done
> if ! echo ${cadena[@]} | grep -q 'compat\snumpad:mac'; then
> 	for (( i=0;i<${#cadena[@]};i++ )); do
> 		nova="$nova ${cadena[$i]},"
> 	done
> 	nova="$nova 'compat${tab}numpad:mac'"
> 	dconf write /org/mate/desktop/peripherals/keyboard/kbd/options "[ $nova ]"
> fi
> gsettings set org.mate.peripherals-keyboard numlock-state          'on'
> ---------------%-----------------%------------------%------------------

I would like to get this fixed before the next release of x2gomatebindings.

Do you think you could write a patch?

Here is an example for a possible approach:
http://code.x2go.org/gitweb?p=x2gomatebindings.git;a=blob;f=lib/x2go/extensions/pre-runcommand.d/005_MATE-monitors-xml-ignore;h=2f77bed691529e5cbbb45e569e196667b5b004d1;hb=a1a6a572d81a49c376eaab875de8343b2781d638

Simply use the extension concept of X2Go Server to hook into there and  
execute code that is necessary.

The goal of such code should be that the Numlock settings are changed  
for X2Go (on session startup e.g.), but that local logins (of the same  
user) are not affected. If that is at all possible...

Mike

-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: [email-masked], http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb